#ifndef __ATTRIBUTES_H
#define __ATTRIBUTES_H

#include "Type.h"

/*
 * Attribute for var_expr expressions (can be assigned)
 */

class LhsExpr
{
 public:
  int result_register;  //value itself (e.g. a[i])
  int address_register; //value address (e.g. a+i)
  Type* type;

  LhsExpr(int result, int address, Type* t);
};

//Pretty constructor
LhsExpr* lhs(int result_register, int address_register, Type* type);

/*
 * Attribute for expr expressions (*cannot* be assigned)
 */

class RhsExpr
{
 public:
  int result_register;  //value itself (e.g. a[i])
  Type* type;

  RhsExpr(int result, Type* t);
};

//Pretty constructor
RhsExpr* rhs(int result_register, Type* type);

#endif
