#ifndef __BASIC_BLOCK_H
#define __BASIC_BLOCK_H

#include "BitVector.h"
#include "Code.h"
#include "PseudoCode.h"

#include <vector>

using namespace std;

class BasicBlock: public Code
{
 public:
  vector<Code*> block;

  BitVector* read_register; //block input
  BitVector* write_register; //block output

  string label;

  BasicBlock(vector<Code*> vec);

  //
  //Implementation of abstract methods
  //

  //Selectors
  BitVector* get_read_register(); //use
  BitVector* get_write_register(); //def
  string get_label();

  //Predicates
  int is_jump();
  int is_label();

  BasicBlock* clone();

  //Pretty printer
  string to_string();
  string to_string_dot();
};

#endif
