#ifndef __BIT_VECTOR_H
#define __BIT_VECTOR_H

#include <iostream>
#include <vector>

using namespace std;

class BitVector
{
 public:
  int size;
  vector<int> bit_set;

  BitVector(int size);

  void insert(int e);
  void insert(vector<int> e);

  int has(int e); //belonging test

  int operator ==(BitVector& b);

  vector<int> to_vector();

  string to_string_dot(); //For .dot output

  BitVector* clone();
};

BitVector& operator |(BitVector& b1, BitVector& b2); //union
BitVector& operator &(BitVector& b1, BitVector& b2); //intersection
BitVector& operator -(BitVector& b1, BitVector& b2); //difference

//pretty-printer
ostream& operator <<(ostream& sout, BitVector& b);

#endif
