#ifndef __CODE_H
#define __CODE_H

#include "BitVector.h"

using namespace std;

class Code
{
 public:
  //Abstract selectors
  virtual BitVector* get_read_register()=0; //use
  virtual BitVector* get_write_register()=0; //def
  virtual string get_label()=0;

  //Abstract predicates
  virtual int is_jump()=0;
  virtual int is_label()=0;

  virtual Code* clone()=0;

  //Abstract pretty printer
  virtual string to_string()=0;
  virtual string to_string_dot()=0; //For dot output
};

#endif
