#ifndef __DAG_H
#define __DAG_H

#include "PseudoCode.h" 
#include "BasicBlock.h" 

#include <iostream>  //For the pretty-printer

#include <vector>
#include <map>

using namespace std;

class Dag
{
 public:
  vector<PseudoCode*> node;
  vector<vector<int> > succ;
  map<int,PseudoCode*> node_reg; //last node defining register 'reg'
  map<PseudoCode*,vector<int> > node_def; //registers (lastly) defined by a node

  map<int,PseudoCode*> def;

  Dag(BasicBlock* basic_block);

  void print_dot(ostream& sout);
  void show_dot();
};

#endif
