/*****************************************************************************
 *              D: a minimal compiler for educational purpose                *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2009 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "label.h"


void reset_labels()
{
  nb_labels = 0;
  top = -1;
}

char* new_label()
{
  char* result = (char*)malloc(10*sizeof(int));
  //WARNING: max label size = 10 characters

  nb_labels++; 
  int string_size = sprintf(result, "label_%d", nb_labels);

  if(string_size>10)
    {
      printf("label:new_label: too much labels\n");
      exit(1);
    }

  return result;
}

void push_label(char* label)
{
  top++;
  label_stack[top] = strdup(label);
}


char* pop_label()
{
  return label_stack[top--];
}


