/*****************************************************************************
 *              D: a minimal compiler for educational purpose                *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2009 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "Type.h"
#include "PseudoCode.h"
#include "Dag.h"
#include "BitVector.h"

#include "Cfg.h"

#include <iostream>
#include <math.h>


/*
#include "code_generation.h"
*/

//Interface with Flex & Bison
extern FILE *yyin;              //from Flex
extern int yyparse(void);       //from Bison
extern int line_number;         //

#include "Register.h"
#include "SymbolTable.h"
#include "Label.h"

extern Cfg* cfg;

int main(int argc, char** argv)
{
  cfg = new Cfg();

  int r0 = new_register();
  int r1 = new_register();
  int r2 = new_register();
  int r3 = new_register();
  int r4 = new_register();

  string loop = "loop";
  string end_loop = "end_loop";

  mov_reg_int(r0,1);
  mov_reg_int(r1,0);
  mov_reg_int(r2,10);
  label(loop);
  cjump(r1,GE,r2,end_loop);
  add(r1,r1,r0);
  mov_reg_int(r3,1);
  add(r4,r3,r0);
  jump(loop);
  label(end_loop);
  add(r4,r4,r0);
 
  cfg->fix_succ();
  cfg->do_liveness();
  Cfg* cfg_bb = cfg->extract_basic_blocks();
  //cfg_bb->print_dot(cout);

  Dag* dag = new Dag((BasicBlock*)cfg_bb->node[2]);
  dag->print_dot(cout);



  //  yyin = fopen(argv[1],"r");
  //  line_number = 1;
  //  int bison_return_code = yyparse();
}
